=== buildscripts/requirements.txt ===
# Jira integration
cryptography >= 2.0.0
jira == 1.0.10
pyjwt == 1.5.3
# Other
pyyaml == 5.1
unittest-xml-reporting == 2.1.0
# Linters
yapf == 0.21.0
mypy == 0.580 ; python_version > "3"
# typing in Python 2 for mypy
typing == 3.6.1; python_version < "3"
pylint == 1.8.3
pydocstyle == 2.1.1
# resmoke.py
-r resmokelib/requirements.txt
# generate_error_codes.py
cheetah3 == 3.0.0; python_version < "3"
jinja2 == 2.10
mock == 2.0.0
click ~= 7.0
evergreen.py == 0.3.9
shrub.py == 0.2.0
structlog ~= 19.1.0
psutil == 5.4.3
